## gfal2 2.3.0

=== CMakeLists.txt ===
## cmake build script for srm-ifce
project (gfal2)
cmake_minimum_required (VERSION 2.6)
message("cmake source dir : ${CMAKE_SOURCE_DIR}")
# default set of options
SET(MAIN_CORE TRUE
        CACHE STRING "enable compilation of the main library")
SET(PLUGIN_LFC TRUE
        CACHE STRING "enable compilation of the lfc plugin")
SET(PLUGIN_SRM TRUE
        CACHE STRING "enable compilation of the srm plugin")
SET(PLUGIN_RFIO TRUE
        CACHE STRING "enable compilation of the RFIO plugin")
SET(PLUGIN_DCAP TRUE
        CACHE STRING "enable compilation of the DCAP plugin")
SET(PLUGIN_FILE TRUE
        CACHE STRING "enable compilation of the local File plugin")
SET(PLUGIN_GRIDFTP TRUE
        CACHE STRING "enable compilation of the GRIDFTP plugin")
SET(PLUGIN_HTTP TRUE
        CACHE STRING "enable compilation of the HTTP plugin")

SET(MAIN_TRANSFER TRUE
        CACHE STRING "enable compilation of the transfer library")

# build type
set(CMAKE_BUILD_TYPE "RelWithDebInfo"
	CACHE STRING "type of build")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
# load module
include(DefineInstallationPaths REQUIRED)
include(MacroCopyFile REQUIRED)
include(ReleaseDebugAutoFlags REQUIRED)
include(CMakeGeneratePkgConfig REQUIRED)
include(MacroAddDoxygen REQUIRED)

find_package(PkgConfig REQUIRED)

#enable testing
INCLUDE(CTest)

#define PROJECT vars
set(PROJECT_NAME_MAIN "gfal2")
set(OUTPUT_NAME_MAIN "gfal2")

set(PROJECT_NAME_TRANSFER "gfal_transfer")
set(OUTPUT_NAME_TRANSFER "gfal_transfer")

set(PROJECT_NAME_LFC "plugin_lfc")
set(OUTPUT_NAME_LFC "gfal_plugin_lfc")

set(PROJECT_NAME_SRM "plugin_srm")
set(OUTPUT_NAME_SRM "gfal_plugin_srm")

set(PROJECT_NAME_RFIO "plugin_rfio")
set(OUTPUT_NAME_RFIO "gfal_plugin_rfio")

set(PROJECT_NAME_DCAP "plugin_dcap")
set(OUTPUT_NAME_DCAP "gfal_plugin_dcap")

set(PROJECT_NAME_GRIDFTP "plugin_gridftp")
set(OUTPUT_NAME_GRIDFTP "gfal_plugin_gridftp")

set(PROJECT_NAME_FILE "plugin_file")
set(OUTPUT_NAME_FILE "gfal_plugin_file")

set(PROJECT_NAME_HTTP "plugin_http")
set(OUTPUT_NAME_HTTP "gfal_plugin_http")

set(VERSION_MAJOR  2)
set(VERSION_MINOR  3)
set(VERSION_PATCH 0)
set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})


# out of project test compilation
SET(ONLY_TESTS FALSE
	CACHE STRING "enable or disable out of project dir")


# libs checks
pkg_check_modules(GLIB2_PKG REQUIRED glib-2.0)
pkg_check_modules(GTHREAD2_PKG REQUIRED gthread-2.0)
pkg_check_modules(UUID_PKG REQUIRED uuid)
pkg_search_module(GLIBMM_PKG REQUIRED glibmm glibmm-2.6 glibmm-2.4)

IF(PLUGIN_SRM)
pkg_check_modules(SRM_IFCE_PKG REQUIRED srm-ifce>=1.15.0)
ENDIF(PLUGIN_SRM)

IF(PLUGIN_HTTP)
pkg_check_modules(GSOAP_SSL_PKG REQUIRED "gsoapssl++")
pkg_check_modules(DAVIX_PKG REQUIRED "davix>=0.0.20")
find_package(gSOAP REQUIRED)
ENDIF(PLUGIN_HTTP)

IF(PLUGIN_GRIDFTP)
pkg_check_modules(GLOBUS_GASS_COPY_PKG REQUIRED globus-gass-copy)
ENDIF(PLUGIN_GRIDFTP)


# general parameters for configuration
add_definitions( -DGFAL_PLUGIN_DIR_DEFAULT="${PLUGIN_INSTALL_DIR}" )
add_definitions( -DGFAL_CONFIG_DIR_DEFAULT="${SYSCONF_INSTALL_DIR}" )
# add file offset 64 for 32 bits
add_definitions( -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_GNU_SOURCE)

include_directories( ${GLIB2_PKG_INCLUDE_DIRS} ${GTHREAD2_PKG_INCLUDE_DIRS})


#install doc license
install(FILES "LICENSE" "README" "RELEASE-NOTES" "VERSION" "DESCRIPTION"
			DESTINATION ${DOC_INSTALL_DIR})
			
# install configuration files
FILE(GLOB lst_conf_files "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/*.conf")
install(FILES ${lst_conf_files}
			DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

IF(NOT ONLY_TESTS)
	add_subdirectory (doc)
	add_subdirectory (src)
ENDIF(NOT ONLY_TESTS)


add_subdirectory (test)
add_subdirectory (testing)

=== DESCRIPTION ===
The Grid File Access Library 2.0 that offers a POSIX interface to the distributed files system supported by WLCG.

Official documentation : https://svnweb.cern.ch/trac/lcgutil/wiki/gfal2

Differents file systems are supported by a collections of GFAL 2.0's plugins, this is a non complete list :

- LFC ( Logical File catalog) with lfn:// url
- SRM ( Storage Resource Manager) with  srm://
- RFIO ( remote file I/O) with rfio://
- DCAP ( remote ftp for Dcache ) with gsidcap://
- HTTP/Webdav  with cluster, third party copy and client side credential support.

=== doc/CMakeLists.txt ===

SET(MAIN_DOC TRUE
	CACHE STRING "enable installation of the main library documentation")	

IF(MAIN_DOC)

	file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/build/html/")
	addDoxyGeneration("Doxyfile.in")
	SET( l_doc "${CMAKE_CURRENT_BINARY_DIR}/build/html/")

	install(DIRECTORY ${l_doc}
			DESTINATION ${DOC_INSTALL_DIR}/html/) # install examples 

ENDIF(MAIN_DOC)



install(FILES "mans/gfal2_version.1"
		DESTINATION ${MAN_INSTALL_DIR}/man1/) # install examples

=== src/CMakeLists.txt ===
## default set of build

	
SET(IS_IFCE FALSE)
# subdir import
add_subdirectory(global)
add_subdirectory(config)
add_subdirectory(file)
add_subdirectory(cancel)
add_subdirectory(externals/utils)
add_subdirectory(externals/g_config_manager)
add_subdirectory(fdesc)

## defaults sources
FILE(GLOB src_posix "posix/*.c")
FILE(GLOB src_common "common/*.c")
FILE(GLOB src_gsimplecache "externals/gsimplecache/*.c")
#version sources
FILE(GLOB src_version "version/*.c")
#define lfc sources
FILE(GLOB src_lfc "common/lfc/*.c")
#define srm sources
FILE(GLOB src_srm "common/srm/*.c")
#define rfio sources
FILE(GLOB src_rfio "common/rfio/*.c")
#define dcap sources
FILE(GLOB src_dcap "common/dcap/*.c")
#define libcpp source
FILE(GLOB src_libcpp "libcpp/*.cpp")
#define logger source
FILE(GLOB src_logger "logger/*.c")
#define exceptions source
FILE(GLOB src_exceptions "exceptions/*.cpp")

# global headers
SET(common_dir	"common/")
SET(posix_dir	"posix/")
SET(mds_dir	"common/mds/")
SET(global_dir	".")
SET(externals_dir	"externals/")


# gfal2 link and link dir
SET(gfal2_link "gfal2")

LIST(APPEND headers_main ${common_dir} ${posix_dir} ${global_dir} 
			${mds_dir}  ${externals_dir})

include_directories(${headers_main} )
add_definitions( -DVERSION="${VERSION_STRING}" -Wall ${GLIB2_PKG_CFLAGS} ${GTHREAD2_PKG_CFLAGS})


LIST(APPEND main_libs ${src_posix} ${src_common} ${src_global} ${src_config}
          ${src_uri} ${src_logger} ${src_g_shared_map}
         ${src_file} ${src_cancel})


IF (MAIN_CORE)

	add_library(gfal2  SHARED ${main_libs} )
        target_link_libraries(gfal2	${UUID_PKG_LIBRARIES} "stdc++" ) # hotfix for libc TLS init bug in EPEL 5
	target_link_libraries(gfal2 ${GLIB2_PKG_LIBRARIES} ${GTHREAD2_PKG_LIBRARIES} 
                                                          "dl" )
	set_target_properties(gfal2	 	PROPERTIES
									VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
									SOVERSION ${VERSION_MAJOR}
									CLEAN_DIRECT_OUTPUT 1
									OUTPUT_NAME ${OUTPUT_NAME_MAIN}
	)
	add_PkgConfigFile_for_Library("gfal2.pc" gfal2 
										HEADER_DIRS "gfal2"
                                                                                CFLAGS " -D_FILE_OFFSET_BITS=64 "
										DESCRIPTION "GFAL 2.0 pkgconfig file"
										REQUIRES "glib-2.0")	
	add_executable(gfal2_version ${src_version})
	target_link_libraries(gfal2_version "gfal2")


	install(TARGETS gfal2 gfal2_version
			RUNTIME       DESTINATION ${BIN_INSTALL_DIR}
			LIBRARY       DESTINATION ${LIB_INSTALL_DIR} )
			
	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gfal2.pc DESTINATION ${PKGCONFIG_FILES_DIR})

	install(FILES "gfal_api.h" "gfal_plugins_api.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/ ) # install headers main

	install(FILES "logger/gfal_logger.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/logger ) # install headers posix

	install(FILES "posix/gfal_posix_api.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/posix ) # install headers posix

	install(FILES   "common/gfal_constants.h"
					"common/gfal_common_plugin_interface.h" 
					"common/gfal_prototypes.h"
					"common/gfal_common_plugin.h"
                    "common/gfal_types.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/common ) # install headers common

	FILE(GLOB l_examples "../testing/example/*.c")
	install(FILES ${l_examples}
			DESTINATION ${DOC_INSTALL_DIR}/examples/ ) # install examples 
			
	install(FILES 	"global/gfal_global.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/global)

    install(FILES "externals/g_config_manager/g_config_manager.h"
            DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/g_config_manager)

ENDIF (MAIN_CORE)



IF(PLUGIN_LFC)

find_package(LFC REQUIRED)
find_package(DPM REQUIRED)


# lfc headers
SET(lfc_dir "common/lfc/")
SET(lfc_headers_dir "${LFC_INCLUDE}/lfc/")
#lcgdm headers
SET(lcgdm_headers_dir "${DPM_INCLUDE}/lcgdm/")

add_definitions( -D_REENTRANT)
add_library(plugin_lfc  SHARED ${src_lfc} ${src_gsimplecache})

target_link_libraries(plugin_lfc ${gfal2_link} ${LFC_LIBRARIES} ${UUID_PKG_LIBRARIES} )
include_directories(${LFC_INCLUDE_DIR} ${LCGDM_INCLUDE_DIR} ${UUID_PKG_INCLUDE_DIR})


set_target_properties(plugin_lfc	 	PROPERTIES
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME ${OUTPUT_NAME_LFC}
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins
)

install(TARGETS		plugin_lfc
	    LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )

install(FILES  "common/lfc/README_PLUGIN_LFC"
		DESTINATION ${DOC_INSTALL_DIR})	
	    
ENDIF(PLUGIN_LFC)


IF(PLUGIN_SRM)


## link to internal bdii system if IS_IFCE=false else to the is_interface
IF (IS_IFCE)

        SET(is_ifce_link	"is_ifce")
        add_definitions(-DMDS_BDII_EXTERNAL=1)
        SET(mds_source "common/mds/gfal_common_mds.c")

ELSE (IS_IFCE)
        add_definitions(-DMDS_BDII_EXTERNAL=0)
        FILE(GLOB mds_source "common/mds/*.c")
        SET(is_ifce_link	"ldap_r")

ENDIF(IS_IFCE)


add_definitions( ${SRM_IFCE_PKG_CFLAGS} )
include_directories( ${SRM_IFCE_PKG_INCLUDE_DIR} ${is_ifce_link})

add_library(plugin_srm  SHARED ${src_srm} ${src_gsimplecache} ${src_uri}  ${mds_source} )
target_link_libraries(plugin_srm ${gfal2_link} ${SRM_IFCE_PKG_LIBRARIES} ${is_ifce_link} gomp gfal2_transfer)


set_target_properties(plugin_srm	 	PROPERTIES
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME ${OUTPUT_NAME_SRM}
                                                                LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins
)

install(TARGETS		plugin_srm
	    LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )

install(FILES  "common/srm/README_PLUGIN_SRM"
		DESTINATION ${DOC_INSTALL_DIR})	

ENDIF(PLUGIN_SRM)


IF(PLUGIN_RFIO)

find_package(DPM REQUIRED)

add_library(plugin_rfio  SHARED ${src_rfio} ${src_gsimplecache} )

target_link_libraries(plugin_rfio ${gfal2_link} ${DPM_LIBRARIES} )
include_directories( ${DPM_INCLUDE_DIR} )
add_definitions( ${DPM_CFLAGS} )

set_target_properties(plugin_rfio	 	PROPERTIES
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME ${OUTPUT_NAME_RFIO}
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins								
)

install(TARGETS		plugin_rfio
	    LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )
  	
install(FILES  "common/rfio/README_PLUGIN_RFIO"
		DESTINATION ${DOC_INSTALL_DIR})	
		
ENDIF(PLUGIN_RFIO)



IF(PLUGIN_DCAP)

find_package(DCAP REQUIRED)

add_definitions( -D_REENTRANT)
add_library(plugin_dcap  SHARED ${src_dcap} ${src_gsimplecache} )

target_link_libraries(plugin_dcap ${gfal2_link} ${DCAP_LIBRARIES})
include_directories( ${DCAP_INCLUDE_DIR} )
add_definitions( ${DCAP_CFLAGS} )

set_target_properties(plugin_dcap	 	PROPERTIES
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME ${OUTPUT_NAME_DCAP}
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins								
)

install(TARGETS		plugin_dcap
	    LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )

install(FILES  "common/dcap/README_PLUGIN_DCAP"
		DESTINATION ${DOC_INSTALL_DIR})	

ENDIF(PLUGIN_DCAP)




add_subdirectory(common/http)


add_subdirectory(transfer)                         
add_subdirectory(common/gridftp)    
add_subdirectory(common/file)

=== test/CMakeLists.txt ===
## src cmake build script for srm-ifce

## default set of build
SET(UNIT_TESTS FALSE
	CACHE STRING "enable compilation of unit tests")
SET(FUNCTIONAL_TESTS FALSE
	CACHE STRING "functional tests for gfal ")
SET(LOAD_TESTS FALSE
        CACHE STRING "load tests for gfal ")
	

IF(ONLY_TESTS)
	pkg_check_modules(GFAL2_PKG REQUIRED gfal2)
	pkg_check_modules(GFAL2_TRANSFER_PKG REQUIRED gfal_transfer)
	SET(OUTPUT_NAME_MAIN ${GFAL2_PKG_LIBRARIES})
	SET(OUTPUT_NAME_TRANSFER ${GFAL2_TRANSFER_PKG_LIBRARIES})	
ENDIF(ONLY_TESTS)

IF(UNIT_TESTS OR FUNCTIONAL_TESTS)
# incldues tests
add_subdirectory(gtest-1.6.0)
ENDIF(UNIT_TESTS OR FUNCTIONAL_TESTS)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/gtest-1.6.0/include)


#mock src
FILE(GLOB src_mock "mock/*.c")
SET(headers_mock "mock/")

include_directories( ${headers_mock} "." ${PROJECT_SOURCE_DIR}/src/externals ${GFAL2_PKG_INCLUDE_DIRS})

link_directories (${PROJECT_BINARY_DIR}/src /)


execute_process(COMMAND cmake -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/conf_test  ${CMAKE_CURRENT_BINARY_DIR}/conf_test) 

#include common library for tests
add_subdirectory(common)


add_subdirectory(functional/gfal2)   
add_subdirectory(functional/old)   
add_subdirectory(loadtests)
add_subdirectory(unit)

=== testing/CMakeLists.txt ===
#
# compilation lines for examples
SET(GFAL_EXAMPLES FALSE
	CACHE STRING "Example for gfal ")

# gfal stat
FILE(GLOB src_gfalstat "example/gfal_teststat.c")
FILE(GLOB src_gfalread "example/gfal_testread.c")
FILE(GLOB src_gfalread "example/gfal_testwrite.c")
FILE(GLOB src_gfalrw "example/gfal_testrw.c")
FILE(GLOB src_gfalget "example/gfal_testget.c")
FILE(GLOB src_gfaltcopy "example/gfalt_copyfile.c")

IF (GFAL_EXAMPLES)


	include_directories( "../src "  "../src/posix/" ${GLIB2_PKG_INCLUDE_DIRS} )

	add_executable(gfal_stat	${src_gfalstat} )
	target_link_libraries(gfal_stat ${OUTPUT_NAME_MAIN} )
	
	add_executable(gfal_read	${src_gfalread} )
	target_link_libraries(gfal_read ${OUTPUT_NAME_MAIN} )

	add_executable(gfal_write	${src_gfalwrite} )
	target_link_libraries(gfal_write ${OUTPUT_NAME_MAIN} )

	add_executable(gfal_rw	${src_gfalrw} )
	target_link_libraries(gfal_rw ${OUTPUT_NAME_MAIN} )
	
	add_executable(gfal_testget	${src_gfalget} )
	target_link_libraries(gfal_testget ${OUTPUT_NAME_MAIN} )
	
	add_executable(gfal_copyfile ${src_gfaltcopy} )
	target_link_libraries(gfal_copyfile ${OUTPUT_NAME_TRANSFER} )
	
ENDIF  (GFAL_EXAMPLES)

=== src/cancel/CMakeLists.txt ===
## default set of build

## defaults sources
FILE(GLOB src_cancel_f "*.c" )
SET(src_cancel ${src_cancel_f} PARENT_SCOPE)

FILE(GLOB header_cancel "gfal_cancel.h")

install(FILES ${header_cancel} DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/cancel)

=== src/externals/CMakeLists.txt ===

add_subdirectory(utils)

=== src/fdesc/CMakeLists.txt ===
## default set of build

## defaults sources

FILE(GLOB header_fdesc "gfal_file_handle.h")

install(FILES ${header_fdesc} DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/fdesc)

=== src/file/CMakeLists.txt ===
## default set of build

## defaults sources
FILE(GLOB src_file "*.c" )
SET(src_file ${src_file} PARENT_SCOPE)

FILE(GLOB header_file_api "gfal_file_api.h")

install(FILES ${header_file_api} DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/file)

=== src/global/CMakeLists.txt ===
## default set of build

## defaults sources
FILE(GLOB src_global_f "*.c" )
SET(src_global ${src_global_f} PARENT_SCOPE)

FILE(GLOB header_global "gfal_global.h")

install(FILES ${header_global} DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/global)

=== src/transfer/CMakeLists.txt ===
## default set of build


## defaults sources
FILE(GLOB src_trans "*.cpp" )
FILE(GLOB src_libcpp "../libcpp/*.cpp")


# gfal2 link and link dir
SET(gfal2_link "gfal2")





IF (MAIN_TRANSFER)


	LIST(APPEND header_transfer "gfal_transfer.h" "gfal_transfer_types.h" "gfal_transfer_plugins.h")

	include_directories( "../ " "../libcpp/" ${GLIB2_PKG_INCLUDE_DIRS} 
						${GTHREAD2_PKG_INCLUDE_DIRS}  ${GLIBMM_PKG_INCLUDE_DIRS})
	add_definitions( ${GLIB2_PKG_CFLAGS} ${GTHREAD2_PKG_CFLAGS} ${GLIBMM_PKG_CFLAGS})
	
        add_library(gfal2_transfer  SHARED ${src_trans} ${src_libcpp} ${src_exceptions} )
	target_link_libraries(gfal2_transfer ${GLIB2_PKG_LIBRARIES} ${GTHREAD2_PKG_LIBRARIES} 
							${UUID_PKG_LIBRARIES} ${gfal2_link}  ${GLIBMM_PKG_LIBRARIES} "dl")
	set_target_properties(gfal2_transfer	 	PROPERTIES
									LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/src
									VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
									SOVERSION ${VERSION_MAJOR}
									CLEAN_DIRECT_OUTPUT 1
									OUTPUT_NAME ${OUTPUT_NAME_TRANSFER}
	)
	add_PkgConfigFile_for_Library("gfal_transfer.pc" gfal2_transfer 
										HEADER_DIRS "gfal2"
										DESCRIPTION "gfal_transfer pkgconfig file"
										REQUIRES "gfal2")

	install(TARGETS gfal2_transfer
			LIBRARY       DESTINATION ${LIB_INSTALL_DIR} )
			
	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gfal_transfer.pc DESTINATION ${PKGCONFIG_FILES_DIR})
	install(FILES ${header_transfer} DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/transfer)
	install(FILES "README_TRANSFER"
			DESTINATION ${DOC_INSTALL_DIR})
ENDIF  (MAIN_TRANSFER)


link_directories (${CMAKE_BINARY_DIR}/src)

=== debian/changelog ===
gfal2 (2.3.0-4) unstable; urgency=low

  * Adapt to new davix (patch from upstream svn)

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Mon, 02 Dec 2013 05:47:29 +0100

gfal2 (2.3.0-3) unstable; urgency=low

  * Fix non-pointer dereference that cause segmentation fault

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Fri, 27 Sep 2013 15:43:22 +0200

gfal2 (2.3.0-2) unstable; urgency=low

  * Remove binary files in source tarball

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Tue, 20 Aug 2013 09:11:13 +0200

gfal2 (2.3.0-1) unstable; urgency=low

  * New upstream release
  * New binary package gfal2-plugin-http

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Fri, 09 Aug 2013 20:49:23 +0200

=== debian/control ===
Source: gfal2
Priority: optional
Maintainer: Mattias Ellert <mattias.ellert@fysast.uu.se>
Build-Depends: debhelper (>= 8.0.0), cmake, doxygen, libglib2.0-dev, libglibmm-2.4-dev, libattr1-dev, libldap2-dev, uuid-dev, liblfc-dev, libdpm-dev, srm-ifce-dev (>= 1.16.0), dcap-dev, libglobus-gass-copy-dev, davix-dev (>= 0.2.7), libgridsite-dev, gsoap, pkg-config, libgtest-dev
Standards-Version: 3.9.5
Section: net
Homepage: https://svnweb.cern.ch/trac/lcgutil/wiki/gfal2

Package: gfal2
Architecture: any
Depends:  libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gfal2-plugin-lfc (= ${binary:Version}), gfal2-plugin-rfio (= ${binary:Version}), gfal2-plugin-dcap (= ${binary:Version}), gfal2-plugin-srm (= ${binary:Version}), gfal2-plugin-gridftp (= ${binary:Version}), gfal2-plugin-http (= ${binary:Version})
Description: Grid file access library 2.0
 GFAL 2.0 offers an a single and simple POSIX-like API for the file
 operations in grids and cloud environments. The set of supported
 protocols depends on the gfal2 installed plugins.

Package: libgfal2-2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Core of the Grid File access Library 2.0
 The main library of gfal2. The gfal protocol support relies on a
 plugin system.

Package: libgfal-transfer2
Section: libs
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: File Transfer logic of gfal2
 gfal-transfer is the high level API for file transfer operations in
 gfal2. It supports third-party copy.

Package: libgfal2-dev
Section: libdevel
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), libglib2.0-dev, libattr1-dev, ${misc:Depends}
Description: Development files of gfal2
 Development files for gfal2

Package: gfal2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Documentation for gfal2
 Documentation, doxygen and examples of gfal2.

Package: gfal2-plugin-lfc
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the lfc access for gfal2
 Provide the lfc support (LFN://) for gfal2. The LFC plugin allows
 read-only POSIX operations for the LFC catalog.

Package: gfal2-plugin-rfio
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the rfio access for gfal2
 Provide the rfio support (RFIO://) for gfal2. The rfio plugin
 provides the POSIX operations for the rfio URLs, the rfio protocol is
 used on the DPM and on the Castor storage systems.

Package: gfal2-plugin-dcap
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), dcap-tunnel-gsi, ${shlibs:Depends}, ${misc:Depends}
Description: Provide the dcap access for gfal2
 Provide the dcap support (GSIDCAP://, DCAP://) for gfal2. The dcap
 plugin provides the POSIX operations for the dcap URLs, the dcap
 protocol is used on the DCACHE storage system

Package: gfal2-plugin-srm
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), libgfal-srm-ifce1 (>= 1.16.0), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the srm access for gfal2
 Provide the srm support (SRM://) for gfal2. The srm plugin provides
 the POSIX operations and the third party transfer support on the SRM
 URLs.

Package: gfal2-plugin-gridftp
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the gridftp access for gfal2
 Provide the gridftp support (GSIFTP://) for gfal2. The gridftp plugin
 provides the POSIX operations and the third party transfer support on
 the GSIFTP URLs.

Package: gfal2-plugin-http
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the http access for gfal2
 Provide the HTTP and WebDAV support for gfal2. The http plugin
 provides the POSIX operations and the third party transfer support on
 the HTTP URLs. This plugin is able to do third-party copy with WebDAV.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/dpkg/buildflags.mk

CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

export CFLAGS CXXFLAGS LDFLAGS

%:
	dh $@

override_dh_auto_configure:
	ln -fs /usr/src/gtest test/gtest
	dh_auto_configure -- -DLIB_SUFFIX="" -DUNIT_TESTS=TRUE

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_install:
	mkdir -p debian/gfal2-doc/usr/share/doc/gfal2-doc
	mv debian/tmp/usr/share/doc/gfal2/examples \
	   debian/tmp/usr/share/doc/gfal2/html \
	   debian/gfal2-doc/usr/share/doc/gfal2-doc
	rm -rf debian/tmp/usr/share/doc
	dh_install --fail-missing

override_dh_auto_clean:
	rm -f test/gtest
	dh_auto_clean

override_dh_auto_test:
	objdir=`ls -d obj-*` ; \
	export GFAL_PLUGIN_DIR=$(CURDIR)/$${objdir}/plugins ; \
	export GFAL_CONFIG_DIR=$(CURDIR)/$${objdir}/test/conf_test ; \
	dh_auto_test -- "ARGS+=-V"
